(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs/add/operator/toPromise'), require('rxjs/AsyncSubject'), require('rxjs/Observable'), require('@angular/core'), require('rxjs/BehaviorSubject'), require('rxjs/ReplaySubject'), require('rxjs/Subject'), require('@angular/common'), require('@angular/core/testing'), require('redux/index')) :
	typeof define === 'function' && define.amd ? define(['exports', 'rxjs/add/operator/toPromise', 'rxjs/AsyncSubject', 'rxjs/Observable', '@angular/core', 'rxjs/BehaviorSubject', 'rxjs/ReplaySubject', 'rxjs/Subject', '@angular/common', '@angular/core/testing', 'redux/index'], factory) :
	(factory((global['ngx-redux-core'] = {}),global.Rx.Observable.prototype,global.Rx,global.Rx,global.ng.core,global.Rx,global.Rx,global.Rx,global.ng.common,global['@angular/core/testing'],global.redux));
}(this, (function (exports,toPromise,AsyncSubject,Observable,core,BehaviorSubject,ReplaySubject,Subject,common,testing,index) { 'use strict';

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ActionInterface = /** @class */ (function () {
    function ActionInterface() {
    }
    return ActionInterface;
}());
var MetadataManager = /** @class */ (function () {
    function MetadataManager() {
    }
    /**
     * @template T
     * @param {?} target
     * @param {?} data
     * @return {?}
     */
    MetadataManager.setActionMetadata = function (target, data) {
        MetadataManager.set(target, MetadataManager.ACTION_KEY, data);
    };
    /**
     * @template T
     * @param {?} target
     * @return {?}
     */
    MetadataManager.getActionMetadata = function (target) {
        return MetadataManager.get(target, MetadataManager.ACTION_KEY, MetadataManager.ACTION_DEFAULT);
    };
    /**
     * @template T
     * @param {?} target
     * @param {?} data
     * @return {?}
     */
    MetadataManager.setActionContextMetadata = function (target, data) {
        MetadataManager.set(target, MetadataManager.ACTION_CONTEXT_KEY, data);
    };
    /**
     * @template T
     * @param {?} target
     * @return {?}
     */
    MetadataManager.getActionContextMetadata = function (target) {
        return MetadataManager.get(target, MetadataManager.ACTION_CONTEXT_KEY, MetadataManager.ACTION_CONTEXT_DEFAULT);
    };
    /**
     * @template T
     * @param {?} target
     * @param {?} data
     * @return {?}
     */
    MetadataManager.setReducerMetadata = function (target, data) {
        MetadataManager.set(target, MetadataManager.REDUCER_KEY, data);
    };
    /**
     * @template T
     * @param {?} target
     * @return {?}
     */
    MetadataManager.getReducerMetadata = function (target) {
        return MetadataManager.get(target, MetadataManager.REDUCER_KEY, MetadataManager.REDUCER_DEFAULT);
    };
    /**
     * @template T
     * @param {?} target
     * @param {?} data
     * @return {?}
     */
    MetadataManager.setStateMetadata = function (target, data) {
        MetadataManager.set(target, MetadataManager.STATE_KEY, data);
    };
    /**
     * @template T
     * @param {?} target
     * @return {?}
     */
    MetadataManager.getStateMetadata = function (target) {
        return MetadataManager.get(target, MetadataManager.STATE_KEY, MetadataManager.STATE_DEFAULT);
    };
    /**
     * @template D, T
     * @param {?} target
     * @param {?} key
     * @param {?} data
     * @return {?}
     */
    MetadataManager.set = function (target, key, data) {
        Reflect['defineMetadata'](key, data, target);
    };
    /**
     * @template D, T
     * @param {?} target
     * @param {?} key
     * @param {?} defaultData
     * @return {?}
     */
    MetadataManager.get = function (target, key, defaultData) {
        defaultData = defaultData || /** @type {?} */ ({});
        return Object.assign({}, defaultData, Reflect['getMetadata'](key, target));
    };
    return MetadataManager;
}());
MetadataManager.ACTION_KEY = Symbol('@ReduxAction');
MetadataManager.ACTION_DEFAULT = {
    contextClazz: null,
    type: '',
};
MetadataManager.ACTION_CONTEXT_KEY = Symbol('@ReduxActionContext');
MetadataManager.ACTION_CONTEXT_DEFAULT = {
    prefix: '',
};
MetadataManager.REDUCER_KEY = Symbol('@ReduxReducer');
MetadataManager.REDUCER_DEFAULT = {
    reducers: [],
};
MetadataManager.STATE_KEY = Symbol('@ReduxState');
MetadataManager.STATE_DEFAULT = {
    name: '',
};
/**
 * @param {?} config
 * @return {?}
 */
function ReduxActionContext(config) {
    return function (constructor) {
        MetadataManager.setActionContextMetadata(constructor, config);
        return constructor;
    };
}
var Registry = /** @class */ (function () {
    function Registry() {
    }
    /**
     * @return {?}
     */
    Registry.reset = function () {
        Registry._store = new AsyncSubject.AsyncSubject();
        Registry._reducers = [];
    };
    /**
     * @param {?} store
     * @return {?}
     */
    Registry.registerStore = function (store) {
        Registry._store.next(store);
        Registry._store.complete();
    };
    /**
     * @param {?} stateName
     * @param {?} types
     * @param {?} reducer
     * @return {?}
     */
    Registry.registerReducer = function (stateName, types, reducer) {
        if (Array.isArray(types)) {
            types.forEach(function (type) {
                Registry._reducers.push({
                    reducer: reducer,
                    stateName: stateName,
                    type: type,
                });
            });
        }
        else {
            Registry._reducers.push({
                reducer: reducer,
                stateName: stateName,
                type: /** @type {?} */ (types),
            });
        }
    };
    /**
     * @param {?} state
     * @return {?}
     */
    Registry.registerState = function (state) {
        Registry.getStore().then(function (store) {
            var /** @type {?} */ stateConfig = MetadataManager.getStateMetadata(state.constructor);
            var /** @type {?} */ initState = state.getInitialState();
            var /** @type {?} */ initStateToResolve = initState;
            if (initState instanceof Observable.Observable) {
                initStateToResolve = initState.toPromise();
            }
            Promise.resolve(initStateToResolve).then(function (initialState) {
                store.dispatch({
                    payload: {
                        initialValue: initialState,
                        name: stateConfig.name,
                    },
                    type: Registry.ACTION_REGISTER_STATE,
                });
            });
        });
    };
    /**
     * @param {?} type
     * @return {?}
     */
    Registry.getReducerItemsByType = function (type) {
        return Registry._reducers
            .filter(function (reducerItem) { return getActionTypeByFunction(reducerItem.type) === type; });
    };
    /**
     * @return {?}
     */
    Registry.getStore = function () {
        return new Promise(Registry._store.subscribe.bind(Registry._store));
    };
    return Registry;
}());
Registry.ACTION_REGISTER_STATE = "@harmowatch/ngx-redux-core/registerState";
Registry._store = new AsyncSubject.AsyncSubject();
Registry._reducers = [];
/**
 * @param {?=} config
 * @return {?}
 */
function ReduxAction(config) {
    return function (target, propertyKey, descriptor) {
        config = Object.assign({
            type: propertyKey,
        }, config || {});
        var /** @type {?} */ originalFunction = descriptor.value;
        var /** @type {?} */ proxyFunction = function () {
            var /** @type {?} */ contextData = MetadataManager.getActionContextMetadata(target.constructor);
            var /** @type {?} */ type = getActionType(contextData.prefix, config.type);
            var /** @type {?} */ returnValue = originalFunction.apply(this, arguments);
            Promise.all([
                Promise.resolve(returnValue),
                Registry.getStore(),
            ]).then(function (_a) {
                var payload = _a[0], store = _a[1];
                store.dispatch({ payload: payload, type: type });
            });
            return returnValue;
        };
        MetadataManager.setActionMetadata(proxyFunction, {
            contextClazz: target.constructor,
            type: config.type,
        });
        descriptor.value = proxyFunction;
    };
}
/**
 * @param {?} target
 * @return {?}
 */
function getActionTypeByFunction(target) {
    var _a = MetadataManager.getActionMetadata(target), type = _a.type, contextClazz = _a.contextClazz;
    var prefix = MetadataManager.getActionContextMetadata(contextClazz).prefix;
    return getActionType(prefix, type);
}
/**
 * @param {...?} rest
 * @return {?}
 */
function getActionType() {
    var rest = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        rest[_i] = arguments[_i];
    }
    return rest.filter(function (i) { return i.length > 0; }).join('');
}
var ReduxModuleRootReducer = /** @class */ (function () {
    function ReduxModuleRootReducer() {
    }
    /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    ReduxModuleRootReducer.reduce = function (state, action) {
        if (action.type === Registry.ACTION_REGISTER_STATE) {
            return ReduxModuleRootReducer.reduceRegisterState(state, /** @type {?} */ (action));
        }
        return ReduxModuleRootReducer.reduceByRegisteredReducers(state, action);
    };
    /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    ReduxModuleRootReducer.reduceRegisterState = function (state, action) {
        var _a = action.payload, name = _a.name, initialValue = _a.initialValue;
        return Object.assign({}, state, (_b = {},
            _b[name] = initialValue,
            _b));
        var _b;
    };
    /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    ReduxModuleRootReducer.reduceByRegisteredReducers = function (state, action) {
        var /** @type {?} */ reducers = Registry.getReducerItemsByType(action.type);
        return reducers.reduce(function (stateToReduce, reducerItem) {
            var stateName = reducerItem.stateName, reducer = reducerItem.reducer;
            return Object.assign({}, stateToReduce, (_a = {},
                _a[stateName] = reducer(stateToReduce[stateName], action),
                _a));
            var _a;
        }, state);
    };
    return ReduxModuleRootReducer;
}());
/**
 * @template S, P
 * @param {?} types
 * @return {?}
 */
function ReduxReducer(types) {
    return function (target, propertyKey) {
        var /** @type {?} */ data = MetadataManager.getReducerMetadata(target.constructor);
        data.reducers.push({ types: types, reducer: target[propertyKey].bind(target) });
        MetadataManager.setReducerMetadata(target.constructor, data);
        return target[propertyKey];
    };
}
var StateDefToken = /** @class */ (function (_super) {
    __extends(StateDefToken, _super);
    function StateDefToken() {
        return _super.call(this, 'StateDefToken') || this;
    }
    return StateDefToken;
}(core.InjectionToken));
var ReduxStateSelectorSubjectType = {};
ReduxStateSelectorSubjectType.DEFAULT = 0;
ReduxStateSelectorSubjectType.SUBJECT = 1;
ReduxStateSelectorSubjectType.BEHAVIOR_SUBJECT = 2;
ReduxStateSelectorSubjectType.REPLAY_SUBJECT = 3;
ReduxStateSelectorSubjectType[ReduxStateSelectorSubjectType.DEFAULT] = "DEFAULT";
ReduxStateSelectorSubjectType[ReduxStateSelectorSubjectType.SUBJECT] = "SUBJECT";
ReduxStateSelectorSubjectType[ReduxStateSelectorSubjectType.BEHAVIOR_SUBJECT] = "BEHAVIOR_SUBJECT";
ReduxStateSelectorSubjectType[ReduxStateSelectorSubjectType.REPLAY_SUBJECT] = "REPLAY_SUBJECT";
var ReduxStateSelector = /** @class */ (function () {
    /**
     * @param {?} expression
     * @param {?=} context
     */
    function ReduxStateSelector(expression, context) {
        this.expression = expression;
        this.context = context;
        if (!expression.startsWith(ReduxStateSelector.DELIMITER)) {
            if (!context) {
                throw new Error('You need to provide a state context if you want to use relativ selectors');
            }
            this.expression = "/" + MetadataManager.getStateMetadata(context).name + "/" + this.expression;
        }
    }
    /**
     * @template S
     * @return {?}
     */
    ReduxStateSelector.prototype.getObservable = function () {
        return this.getSubject().asObservable();
    };
    /**
     * @template S
     * @param {?} initialValue
     * @return {?}
     */
    ReduxStateSelector.prototype.getBehaviorSubject = function (initialValue) {
        return /** @type {?} */ (this.getBySubjectType(ReduxStateSelectorSubjectType.BEHAVIOR_SUBJECT, initialValue));
    };
    /**
     * @template S
     * @return {?}
     */
    ReduxStateSelector.prototype.getReplaySubject = function () {
        return /** @type {?} */ (this.getBySubjectType(ReduxStateSelectorSubjectType.REPLAY_SUBJECT));
    };
    /**
     * @template S
     * @return {?}
     */
    ReduxStateSelector.prototype.getSubject = function () {
        return /** @type {?} */ (this.getBySubjectType(ReduxStateSelectorSubjectType.SUBJECT));
    };
    /**
     * @template S
     * @param {?} type
     * @param {?=} initialValue
     * @return {?}
     */
    ReduxStateSelector.prototype.getBySubjectType = function (type, initialValue) {
        var _this = this;
        var /** @type {?} */ subject;
        switch (type) {
            case ReduxStateSelectorSubjectType.REPLAY_SUBJECT:
                subject = new ReplaySubject.ReplaySubject();
                break;
            case ReduxStateSelectorSubjectType.SUBJECT:
                subject = new Subject.Subject();
                break;
            default:
                subject = new BehaviorSubject.BehaviorSubject(initialValue || null);
        }
        Registry.getStore().then(function (store) {
            subject.next(_this.getValueFromState(store.getState()));
            store.subscribe(function () { return subject.next(_this.getValueFromState(store.getState())); });
        });
        return subject;
    };
    /**
     * @template T, S
     * @param {?} state
     * @return {?}
     */
    ReduxStateSelector.prototype.getValueFromState = function (state) {
        return this.expression.split(ReduxStateSelector.DELIMITER)
            .filter(ReduxStateSelector.isPropertyKeyValid)
            .reduce(function (previousValue, propertyKey) {
            if (!previousValue || !previousValue[propertyKey]) {
                return null;
            }
            return previousValue[propertyKey];
        }, state);
    };
    /**
     * @param {?} propertyKey
     * @return {?}
     */
    ReduxStateSelector.isPropertyKeyValid = function (propertyKey) {
        return propertyKey !== '';
    };
    return ReduxStateSelector;
}());
ReduxStateSelector.DELIMITER = '/';
var ReduxSelectPipe = /** @class */ (function () {
    /**
     * @param {?} stateDef
     */
    function ReduxSelectPipe(stateDef) {
        this.stateDef = stateDef;
    }
    /**
     * @param {?} selector
     * @return {?}
     */
    ReduxSelectPipe.prototype.transform = function (selector) {
        return new ReduxStateSelector(selector, this.stateDef.provider).getObservable();
    };
    return ReduxSelectPipe;
}());
ReduxSelectPipe.decorators = [
    { type: core.Pipe, args: [{ name: 'reduxSelect' },] },
];
/**
 * @nocollapse
 */
ReduxSelectPipe.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core.Inject, args: [StateDefToken,] },] },
]; };
/**
 * @param {?} expression
 * @param {?=} context
 * @return {?}
 */
function ReduxSelect(expression, context) {
    return function (target, propertyKey) {
        var /** @type {?} */ selector;
        Object.defineProperty(target, propertyKey, {
            configurable: true,
            enumerable: true,
            get: function () {
                if (!selector) {
                    selector = new ReduxStateSelector(expression, context);
                }
                return selector.getObservable();
            },
        });
    };
}
/**
 * @param {?} config
 * @return {?}
 */
function ReduxState(config) {
    return function (constructor) {
        MetadataManager.setStateMetadata(constructor, config);
        return constructor;
    };
}
var ReduxStore = /** @class */ (function (_super) {
    __extends(ReduxStore, _super);
    function ReduxStore() {
        return _super.call(this, 'ReduxStore') || this;
    }
    return ReduxStore;
}(core.InjectionToken));
var ReduxCommonModule = /** @class */ (function () {
    function ReduxCommonModule() {
    }
    return ReduxCommonModule;
}());
ReduxCommonModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [
                    ReduxSelectPipe,
                ],
                exports: [
                    ReduxSelectPipe,
                ],
            },] },
];
/**
 * @nocollapse
 */
ReduxCommonModule.ctorParameters = function () { return []; };
var StateDefinitionManager = /** @class */ (function () {
    function StateDefinitionManager() {
    }
    /**
     * @param {?} stateDef
     * @return {?}
     */
    StateDefinitionManager.registerReducers = function (stateDef) {
        if (stateDef.reducers) {
            var /** @type {?} */ stateMetadata_1 = MetadataManager.getStateMetadata(stateDef.provider);
            stateDef.reducers
                .map(function (reducer) { return MetadataManager.getReducerMetadata(reducer.constructor); })
                .forEach(function (metadata) {
                metadata.reducers.forEach(function (reducer) {
                    Registry.registerReducer(stateMetadata_1.name, reducer.types, reducer.reducer);
                });
            });
        }
    };
    return StateDefinitionManager;
}());
var ReduxTestingModule = /** @class */ (function () {
    function ReduxTestingModule() {
        Registry.reset();
        Registry.registerStore(ReduxTestingModule.storeFactory());
    }
    /**
     * @param {?} stateDef
     * @return {?}
     */
    ReduxTestingModule.addStateDefinition = function (stateDef) {
        Registry.registerState(testing.TestBed.get(stateDef.provider));
        StateDefinitionManager.registerReducers(stateDef);
    };
    /**
     * @return {?}
     */
    ReduxTestingModule.storeFactory = function () {
        return index.createStore(ReduxModuleRootReducer.reduce, {});
    };
    return ReduxTestingModule;
}());
ReduxTestingModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    ReduxCommonModule,
                ],
            },] },
];
/**
 * @nocollapse
 */
ReduxTestingModule.ctorParameters = function () { return []; };
var ReduxModule = /** @class */ (function () {
    /**
     * @param {?=} stateDefs
     * @param {?=} store
     * @param {?=} injector
     */
    function ReduxModule(stateDefs, store, injector) {
        if (stateDefs === void 0) { stateDefs = []; }
        if (store === void 0) { store = null; }
        var _this = this;
        this.injector = injector;
        if (store) {
            Registry.registerStore(store);
        }
        stateDefs
            .filter(function (stateDef) { return !!stateDef; })
            .map(function (stateDef) {
            return {
                metadata: MetadataManager.getStateMetadata(stateDef.provider),
                stateDef: stateDef,
            };
        })
            .filter(function (_a) {
            var metadata = _a.metadata;
            return !ReduxModule.knownStateDefinitions[metadata.name];
        })
            .forEach(function (_a) {
            var metadata = _a.metadata, stateDef = _a.stateDef;
            _this.initState(stateDef);
            ReduxModule.knownStateDefinitions[metadata.name] = stateDef;
        });
    }
    /**
     * @param {?} stateDef
     * @return {?}
     */
    ReduxModule.prototype.initState = function (stateDef) {
        Registry.registerState(this.injector.get(stateDef.provider));
        StateDefinitionManager.registerReducers(stateDef);
    };
    /**
     * @param {?=} config
     * @return {?}
     */
    ReduxModule.forChild = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: ReduxModule,
            providers: [
                { provide: StateDefToken, useValue: config.state || null, multi: true },
                config.state ? config.state.provider : null,
            ],
        };
    };
    /**
     * @param {?=} config
     * @return {?}
     */
    ReduxModule.forRoot = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: ReduxModule,
            providers: config.state ? [
                { provide: ReduxStore, useFactory: config.storeFactory || ReduxModule.defaultStoreFactory },
                { provide: StateDefToken, useValue: config.state || null, multi: true },
                config.state ? config.state.provider : null,
            ] : [
                { provide: ReduxStore, useFactory: config.storeFactory || ReduxModule.defaultStoreFactory },
                { provide: StateDefToken, useValue: config.state || null, multi: true },
            ],
        };
    };
    /**
     * @return {?}
     */
    ReduxModule.defaultStoreFactory = function () {
        return index.createStore(ReduxModuleRootReducer.reduce, {}, ReduxModule.defaultEnhancerFactory());
    };
    /**
     * @return {?}
     */
    ReduxModule.defaultEnhancerFactory = function () {
        if (console && window['__REDUX_DEVTOOLS_EXTENSION__'] && core.isDevMode()) {
            return window['__REDUX_DEVTOOLS_EXTENSION__']();
        }
        return ReduxModule.nullEnhancer;
    };
    /**
     * @param {?} next
     * @return {?}
     */
    ReduxModule.nullEnhancer = function (next) {
        return next;
    };
    return ReduxModule;
}());
ReduxModule.knownStateDefinitions = {};
ReduxModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    ReduxCommonModule,
                    common.CommonModule,
                ],
            },] },
];
/**
 * @nocollapse
 */
ReduxModule.ctorParameters = function () { return [
    { type: Array, decorators: [{ type: core.Optional }, { type: core.Inject, args: [StateDefToken,] },] },
    { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [ReduxStore,] },] },
    { type: core.Injector, },
]; };

exports.ActionInterface = ActionInterface;
exports.ReduxActionContext = ReduxActionContext;
exports.ReduxAction = ReduxAction;
exports.getActionTypeByFunction = getActionTypeByFunction;
exports.getActionType = getActionType;
exports.ReduxModuleRootReducer = ReduxModuleRootReducer;
exports.ReduxReducer = ReduxReducer;
exports.ReduxSelect = ReduxSelect;
exports.ReduxSelectPipe = ReduxSelectPipe;
exports.ReduxStateSelector = ReduxStateSelector;
exports.ReduxStateSelectorSubjectType = ReduxStateSelectorSubjectType;
exports.ReduxState = ReduxState;
exports.ReduxStore = ReduxStore;
exports.ReduxTestingModule = ReduxTestingModule;
exports.ReduxModule = ReduxModule;
exports.ɵc = ReduxCommonModule;
exports.ɵa = StateDefToken;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-redux-core.umd.js.map
